{ NiNC (NiNC Is No Crack) Version One-Point-Too
  ---------------------------------------------
  this program is released under the bsd license,
  available from opensource.org and on my site.

  a copy of this license is also bundled along in
  the zip file you got this file from.
}

program ninc;
uses crt, dos;

const
    secsToWait  = 5;  { seconds to wait before reverting to the original date }

var
    runModeSync                                     : boolean;
    timeDummy, curSecnd, newDay, newMonth, newYear,
    oldSec, oldSec100, oldMinut, oldHour,
    oldDay, oldDayOfWeek, oldMonth, oldYear         : word;

procedure show_help;
    begin
        clrscr;
        writeln('NiNC (NiNC Is No Crack) Usage');
        writeln('-----------------------------');
        writeln;
        writeln('ninc.exe <month> <day> <year> <run_sync> <app_to_launch> <app_params>');
        writeln;
        writeln('to set the <month>, <day>, or <year> values to their current');
        writeln('system values, send a zero as parameter values.  <year> will');
        writeln('accept double-digit values.  ninc will interpret them as ha-');
        writeln('the first two digits of the current year.');
        writeln;
        writeln('<run_sync> is a boolean value that determines whether or not');
        writeln('ninc should wait for your application to finish running, be-');
        writeln('fore it reverts the date to its original setting.');
        writeln;
        writeln('<app_params> is completely optional.  for more details, read');
        writeln('the bundled documentation.');
        writeln;
        halt;
    end;

procedure process_params;
var code    : longint;
    tmpyear : string;
    sync    : shortint;
    begin
        val(paramstr(4), sync, code);
        if sync <> 0 then runModeSync := TRUE;

        val(paramstr(1), newMonth, code);
        val(paramstr(2), newDay, code);

        if length(paramstr(3)) = 4 then
            tmpyear := paramstr(3)
        else if length(paramstr(3)) = 2 then
            tmpyear := '20' + paramstr(3)
        else
            writeln('error!  wrong length for <year> parameter');

        val(tmpyear, newYear, code);
    end;

begin
    if paramcount = 0 then show_help;
    if paramcount < 5 then show_help;

    { save the current system date/time }
    getDate(oldYear, oldMonth, oldDay, oldDayOfWeek);
    getTime(oldHour, oldMinut, oldSec, oldSec100);

    if (oldHour = 12) and (oldMinut = 59) and (oldSec <= 55) then
        oldDay := oldDay + 1;

    { parse the parameters as necessary }
    process_params;
    if newMonth = 0 then newMonth  := oldMonth;
    if newDay   = 0 then newDay    := oldDay;
    if newYear  = 0 then newYear   := oldYear;

    { now set the new date }
    setDate(newYear, newMonth, newDay);

    { determine execflag mode}
    if runModeSync then ExecFlags := efSync else ExecFlags := efAsync;
    { execute the target application with the last parameter as params for it }
    exec(paramstr(5), paramstr(6));
    if doserror <> 0 then
        { something went wrong...  alert the user }
        begin
            writeln('error detected in the launch of ' + paramstr(4));
            writeln('reverting to buffered system date');
            writeln;
            write('error code: ', doserror);
        end;

    { return the old values to the system }
    if runModeSync = FALSE then
        repeat
            getTime(timeDummy, timeDummy, curSecnd, timeDummy);
        until curSecnd = secsToWait;
    setDate(oldYear, oldMonth, oldDay);
end.
